//
//  IOptPlugin.h
//
//  Created by Vadim Kalinsky.
//  Copyright 2006 Art. Lebedev studio. All rights reserved.

#import <Cocoa/Cocoa.h>

#define EVENT_ACTIVATE 1
#define EVENT_DEACTIVATE 2

@protocol IOptPlugin

// Create plugin instance of corresponding subplugin type.
+(id)createInstance:(int)subType;

// Called three times a second.
// Should return true if anything painted, no means previous image should be used.
-(bool)Paint;

// called on keydown. should return fast.
-(void)OnKeyDown;

-(void)SetProperties:(NSDictionary*)prefsDictionary;
-(NSDictionary*)GetProperties;

// Shows plugin properties dialog. 
-(bool)ShowProperties;

// Plugin life cicle is OnEvent(ACTIVATE) -> Paint(),Paint().. -> OnEvent(DEACTIVATE)
// ACTIVATE/DEACTIVATE can be used to allocate resources requied for painting
// Should return true. Should return fast.
-(bool)OnEvent:(int)event;

@end
