//
//  Plugin.m
//  PROJECTNAME
//
//  Created by FULLUSERNAME on DATE.
//  Copyright ORGANIZATIONNAME YEAR. All rights reserved.
//

#import "Plugin.h"
#import "PrefsController.h"

NSBundle* g_pluginBundle;

@implementation PROJECTNAME

+(void)initialize
{
	g_pluginBundle = [NSBundle bundleForClass:self];
}

+(id)createInstance:(int)subType
{
	return [[self alloc] initWithSubtype:subType];
}

-(id)initWithSubtype:(int)subType
{
	m_Prefs = [[NSMutableDictionary alloc] initWithObjectsAndKeys:
		@"Hello, world!", @"Prefix",
		nil];
	return self;
}

-(bool)Paint
{
	[[NSColor whiteColor] set];
	[NSBezierPath fillRect:NSMakeRect(0,0,96,96)];
	
	NSDateFormatter *dateFormatter = [[[NSDateFormatter alloc]
		initWithDateFormat:@"%1H:%M:%S" allowNaturalLanguage:NO] autorelease];
	NSString *formattedDateString = [dateFormatter stringFromDate:[NSCalendarDate date]];
	
	[formattedDateString drawWithRect:NSMakeRect(10,10,96,60) options:nil attributes:nil];
	
	NSString* sPrefix = [m_Prefs objectForKey:@"Prefix"];
	[sPrefix drawWithRect:NSMakeRect(10,30,96,36) options:nil attributes:nil];
	
	return true;
}

-(bool)OnEvent:(int)event
{
	switch(event)
	{
		case EVENT_ACTIVATE:
			break;
			
		case EVENT_DEACTIVATE:
			break;
	}
	
	return true;
}

-(void)OnKeyDown:(int)button
{
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	NSTask* task = [[NSTask alloc] init];
	
	[task setLaunchPath:@"/usr/bin/open"];
	[task setArguments:[NSArray arrayWithObjects:@".", nil]];

	[task launch];
	[task release];
	
	[pool release];
}

-(void)SetProperties:(NSDictionary*)prefsDictionary
{
	NSEnumerator* e = [prefsDictionary keyEnumerator];
	id key;
	while( nil != (key = [e nextObject]) )
	{
		[m_Prefs setObject:[prefsDictionary objectForKey:key] forKey:key];
	}
}

-(NSDictionary*)GetProperties
{
	return m_Prefs;
}

-(bool)ShowProperties
{
	PrefsController* controller = [[PrefsController alloc] initWithProperties:m_Prefs];
	
	[controller showProperties];
	
	[m_Prefs setObject:[NSString stringWithString:controller->prefixValue] forKey:@"Prefix"];
	
	[controller release];

	return true;
}

@end
