//
//  PrefsController.m
//  PROJECTNAME
//
//  Created by FULLUSERNAME on DATE.
//  Copyright ORGANIZATIONNAME YEAR. All rights reserved.
//

#import "PrefsController.h"

extern NSBundle* g_pluginBundle;

@implementation PrefsController

- (id)initWithProperties:(NSDictionary*)prefs
{
	if( nil == (self = [super init]) )
	{
		return self;
	}

	prefixValue = [NSMutableString stringWithString:[prefs objectForKey:@"Prefix"]];	
	return self;
}

- (void)awakeFromNib
{
	[prefix setStringValue:prefixValue];
}

- (void)showProperties
{
	NSWindow* wnd = nil;

	if( [self window] == nil )
	{
		[self initWithWindowNibName:@"Preferences"];
    
		[[self window] setDelegate: self]; // also forces window to load
		
		wnd = [self window];

		if( wnd == nil )
		{
			NSLog( @"win is null, aborted" );
			return;
		}
	}
		
	[NSApp beginSheet:wnd
		modalForWindow:[NSApp mainWindow]
		modalDelegate:nil
		didEndSelector:nil
		contextInfo:nil];
		
	[NSApp runModalForWindow:wnd];

	[NSApp endSheet:wnd];
	[wnd orderOut:self];
	
	[[self window] setDelegate:nil];
}

- (IBAction)confirmPrefsSheet:(id)sender
{
	[prefixValue setString:[prefix stringValue]];
	[self cancelPrefsSheet:nil];
}

- (IBAction)cancelPrefsSheet:(id)sender
{
	[NSApp stopModal];
}

@end
